<template>
  <div>
    <at-table
      @load="loadData"
      :data="data"
      :page-result="pageResult"
      ref="AtTable"
      :default-sorter="[
        {direction: 'DESC', property: 'project_code_'},
        {direction: 'DESC', property: 'project_name_'},
      ]"
      :dialogTitle="dialogTitle"
      :dialogVisible="dialogVisible"
      @select-all="handleSelect"
      @select="handleSelect"
      @handleDialogCancel="handleDialogCancel"
      @handleDialogClose="handleDialogClose"
      @handleDialogSubmit="handleDialogSubmit"
      @row-dblclick="handleRowDBClick"
    >
      <template v-slot:searchInput>
        <el-form
          ref="searchForm"
          :model="searchForm"
          label-width="80px"
          class="search-top"
          @submit.native.prevent
        >
          <project-info-selector
            v-if="isShow"
            v-model="searchForm.projectId"
            @keyup.enter.native="handleSearch"
          ></project-info-selector>
          <dict-select
            v-model="searchForm.decisionBasisType"
            dictCode="xmlx-jcyj-jcwjlx"
            validate="required"
            placeholder="请选择决策类型"
            :clearable="true"
            @keyup.enter.native="handleSearch"
          />
          <!-- <el-input
            v-model="searchForm.decisionBasisPersion"
            placeholder="请输入经办人"
            clearable
            @keyup.enter.native="handleSearch"
          ></el-input> -->
          <el-date-picker
            v-model="searchForm.decisionBasisTime"
            type="date"
            placeholder="请选择决策时间"
            value-format="yyyy-MM-dd"
            format="yyyy-MM-dd"
          >
          </el-date-picker>
          <el-button
            size="small"
            @click="handleSearch"
            type="primary"
            class="el-icon-search search-btn"
          >查询</el-button>
          <el-button
            size="small"
            @click="handleReset"
            type="primary"
            plain
            class="el-icon-refresh"
          >重置</el-button>
        </el-form>
      </template>
      <template v-slot:operationBtn>
        <el-button
          size="small"
          type="primary"
          @click="handleAdd"
          icon="el-icon-plus"
        >添加</el-button>
        <ht-delete-button
          :url="deleteUrl"
          :htTable="$refs.AtTable"
          :requestMethod="'POST'"
        >删除</ht-delete-button>
        <import-file
          :importData="importData"
          @load="load"
        ></import-file>
        <el-button
          size="small"
          type="primary"
          @click="handleExport"
          icon="el-icon-download"
          plain
          style="margin-left: 10px"
        >导出</el-button>
      </template>
      <template>
        <el-table-column
          type="selection"
          width="55"
          align="center"
        >
        </el-table-column>
        <el-table-column
          type="index"
          label="序号"
          width="55"
          align="center"
        >
        </el-table-column>
        <!-- <el-table-column
          prop="projectInfo.projectCode"
          label="项目代码"
          align="center"
          min-width="150"
          :show-overflow-tooltip="true"
        >
        </el-table-column> -->
        <el-table-column
          prop="projectInfo.projectName"
          label="项目名称"
          align="center"
          min-width="150"
          :show-overflow-tooltip="true"
        >
        </el-table-column>
        <el-table-column
          prop="decisionBasisType"
          label="决策类型"
          align="center"
          :show-overflow-tooltip="true"
        >
          <template slot-scope="scope">
            {{
                getDictMultipleName(
                  'xmlx-jcyj-jcwjlx',
                  scope.row.decisionBasisType
                )
              }}
          </template>
        </el-table-column>
        <el-table-column
          prop="decisionBasisTime"
          label="决策时间"
          align="center"
          width="130"
        >
        </el-table-column>
        <el-table-column
          prop="decisionBasisPersion"
          label="经办人"
          align="center"
        >
        </el-table-column>
        <el-table-column
          prop="decisionBasisDescribe"
          label="决策描述"
          align="center"
          :show-overflow-tooltip="true"
        >
        </el-table-column>
        <el-table-column
          prop="remarks"
          label="备注"
          align="center"
          :show-overflow-tooltip="true"
          width="120"
        >
        </el-table-column>
      </template>
      <!-- 弹框 -->
      <template v-slot:dialogContent>
        <el-form
          ref="ruleForm"
          data-vv-scope="form"
          status-icon
          :model="form"
          :rules="rules"
          label-width="100px"
          v-if="dialogVisible"
          :label-position="labelPosition"
          v-loading.fullscreen="loading"
        >
          <el-row :gutter="20">
            <el-col :span="12">
              <el-form-item
                label="项目名称"
                prop="projectInfo.projectName"
              >
                <el-input
                  v-model="form.projectInfo.projectName"
                  placeholder="请选择项目名称"
                  @focus="handleFocusProject"
                  :disabled="!isShow"
                  clearable
                >
                  <el-button
                    type="primary"
                    @click="handleFocusProject"
                    slot="append"
                    icon="el-icon-search"
                  ></el-button>
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <!-- <el-form-item label="项目代码" prop="projectInfo.projectCode">
                <el-input
                  v-model="form.projectInfo.projectCode"
                  placeholder="请输入项目代码"
                  :disabled="!isShow"
                  clearable
                ></el-input>
              </el-form-item> -->
              <el-form-item
                label="经办人"
                prop="decisionBasisPersion"
              >
                <el-input
                  v-model="form.decisionBasisPersion"
                  placeholder="请输入经办人"
                  clearable
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row :gutter="20">
            <el-col :span="12">
              <el-form-item
                label="决策类型"
                prop="decisionBasisType"
                label-width="100px"
              >
                <dict-select
                  v-model="form.decisionBasisType"
                  dictCode="xmlx-jcyj-jcwjlx"
                  placeholder="请选择决策类型"
                  class="basisType"
                  :multiple="true"
                  :clearable="true"
                />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item
                label="决策时间"
                prop="decisionBasisTime"
              >
                <el-date-picker
                  v-model="form.decisionBasisTime"
                  type="date"
                  placeholder="请输入决策时间"
                  class="basisType"
                  value-format="yyyy-MM-dd"
                  format="yyyy-MM-dd"
                >
                </el-date-picker>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span='12'>
              <el-form-item
                label="年度计划"
                prop="decisionAnnualPlanName"
              >
                <el-input
                  v-model="form.decisionAnnualPlanName"
                  placeholder="请选择年度计划"
                  @focus="handleFocusAnnualPlan"
                  :disabled='isDisabledPlanId'
                  clearable
                >
                  <el-button
                    type="primary"
                    @click="handleFocusAnnualPlan"
                    slot="append"
                    :disabled='isDisabledPlanId'
                    icon="el-icon-search"
                  ></el-button>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-form-item
            label="决策描述"
            prop="decisionBasisDescribe"
          >
            <el-input
              type="textarea"
              v-model="form.decisionBasisDescribe"
              placeholder="请输入决策描述"
            ></el-input>
          </el-form-item>
          <el-form-item
            label="备注"
            prop="remarks"
          >
            <el-input
              type="textarea"
              v-model="form.remarks"
              placeholder="请输入备注"
            ></el-input>
          </el-form-item>
          <file-table
            @handleFile="accessoryInfo"
            :file="form.accessoryInfo"
            :info='"上传请示、决策相关会议纪要等文件"'
          />
        </el-form>
      </template>
      <project-info-dialog
        ref="project"
        :single="true"
        @select="handleSelectProject"
      ></project-info-dialog>
      <annual-plan-dialog
        ref="annualPlan"
        :single="true"
        @select="handleSelectAnnualPlan"
      ></annual-plan-dialog>
    </at-table>
  </div>
</template>
<script>
import ProjectInfoDialog from '@/components/dialog/ProjectInfoDialog.vue'
import AnnualPlanDialog from '@/components/dialog/AnnualPlanDialog.vue'
import req from '@/request.js'
export default {
  name: 'DecisionBasis',
  components: {
    ProjectInfoDialog,
    AnnualPlanDialog
  },
  props: {
    pid: {
      type: String,
      default: ''
    },
    isShow: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      importData: {
        title: '决策依据导入',
        templateName: '决策依据模板.xls',
        downloadUrl: '/../fvue/static/excel/ExportDecisionBasis.xlsx',
        showProject: true,
        importUrl:
          window.context.cqxy +
          '/biz/projectApproval/decisionBasis/v1/importExcelData',
        projectId: ''
      },
      loading: false,
      projectObj: [], //获取的所有项目数组
      labelPosition: 'right', //表单对齐方式
      searchForm: {
        projectId: '',
        decisionBasisPersion: '',
        decisionBasisType: '',
        decisionBasisTime: ''
      }, //顶部搜索参数
      data: [], //表格数据
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0
      },
      form: {
        decisionBasisPersion: '',
        decisionAnnualPlanName: '',
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: []
      },
      dialogVisible: false,
      dialogTitle: '添加',
      isDisabledPlanId: true,
      //表单验证
      rules: {
        'projectInfo.projectName': {
          required: true,
          message: '项目名称不能为空',
          trigger: 'blur'
        }
        // 'projectInfo.projectCode': {
        //   required: true,
        //   message: '项目代码不能为空',
        //   trigger: 'blur',
        // },
        // decisionBasisType: {
        //   required: true,
        //   message: '文件类型不能为空',
        //   trigger: 'blur',
        // },
        // decisionBasisTime: {
        //   required: true,
        //   message: '决策时间不能为空',
        //   trigger: 'blur',
        // },
        // decisionBasisPersion: {
        //   required: true,
        //   message: '经办人不能为空',
        //   trigger: 'blur',
        // },
      }
    }
  },
  computed: {
    deleteUrl: function() {
      return (
        window.context.cqxy + '/biz/projectApproval/decisionBasis/v1/delete'
      )
    }
  },
  mounted() {
    this.initProjectAll()
  },
  watch: {
    'form.decisionBasisType': function(newValue, oldValue) {
      if (!newValue || newValue.length == 0) {
        this.isDisabledPlanId = true
      } else if (
        Object.prototype.toString.call(newValue) == '[object String]'
      ) {
        if (newValue == '5') {
          this.isDisabledPlanId = false
        } else {
          this.isDisabledPlanId = true
        }
      } else {
        if (newValue instanceof Array) {
          if (newValue.includes('5')) {
            this.isDisabledPlanId = false
          } else {
            this.isDisabledPlanId = true
          }
        }
      }
    }
  },
  methods: {
    handleReset() {
      this.searchForm.projectId = ''
      this.searchForm.decisionBasisPersion = ''
      this.searchForm.decisionBasisTime = ''
      this.searchForm.decisionBasisType = ''
      this.$refs['searchForm'].resetFields()
      this.pageResult = {
        page: 1,
        pageSize: 20,
        total: 0
      }
      this.$refs['searchForm'].resetFields()
      this.$nextTick(() => {
        this.$refs.AtTable.load()
      })
    },
    handleSelectProject(data) {
      this.form.decisionBasisPersion = data.projectManager
      this.form.projectInfo.projectName = data.projectName
      this.form.projectInfo.projectCode = data.projectCode
      this.form.projectId = data.id
      this.$refs.ruleForm.clearValidate()
    },
    handleSelectAnnualPlan(data) {
      this.form.decisionAnnualPlanId = data.id
      this.form.decisionAnnualPlanName = data.projectName
    },
    //打开选择项目弹框
    handleFocusProject() {
      this.$refs.project.open()
    },
    handleFocusAnnualPlan() {
      this.$refs.annualPlan.open()
    },
    //导入后重新加载数据
    load() {
      this.$refs.AtTable.load()
    },
    //导出
    handleExport() {
      let query = []
      let search = {
        'pm.ID_': this.searchForm.projectId,
        decisionBasisTime: this.searchForm.decisionBasisTime,
        decisionBasisType: this.searchForm.decisionBasisType
      }
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      let param = {
        pageBean: {
          page: 1,
          pageSize: -1,
          showTotal: true
        },

        querys: query,
        sorter: []
      }
      req
        .downloadPostCopy(
          '${cqxy}/biz/projectApproval/decisionBasis/v1/exportDataToExcel',
          param
        )
        .then(res => {
          if (res.status == 200) {
            this.$message.success('导出成功')
          } else {
            this.$message.error('导出失败')
          }
        })
    },
    //获取附件信息
    accessoryInfo(info) {
      this.form.accessoryInfo = info
    },
    //初始获取所有项目数据
    initProjectAll() {
      //初始获取所有项目数据
      if (this.isShow) {
        this.$http.post('${cqxy}/biz/projectManagement/pm/v1/All').then(
          res => {
            this.projectObj = res.data.value
          },
          error => {
            reject(error)
          }
        )
      } else {
        let params = {
          pageBean: {
            page: 1,
            pageSize: 500,
            total: 0
          },
          querys: [
            {
              group: 'main',
              operation: 'EQUAL',
              property: 'id',
              relation: 'AND',
              value: this.pid
            }
          ]
        }
        this.$http
          .post('${cqxy}/biz/projectManagement/pm/v1/page', params)
          .then(res => {
            if (res.data.state) {
              let resp = res.data.value
              this.projectObj = resp.rows
            }
          })
      }
    },
    //查询
    handleSearch() {
      this.$refs.AtTable.load()
    },
    afterSaveData() {
      setTimeout(() => {
        this.form = {
          decisionBasisPersion: '',
          projectInfo: {
            projectName: '',
            projectCode: ''
          },
          accessoryInfo: []
        }
        this.dialogVisible = false
        this.$refs.AtTable.load()
      }, 500)
    },
    handleAdd() {
      this.dialogTitle = '添加'
      this.dialogVisible = true
      this.form = {
        decisionBasisPersion: '',
        decisionBasisType: '',
        decisionAnnualPlanName: '',
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: []
      }
      if (this.isShow) {
        let selectedProject = this.projectObj.find(item => {
          if (item.currentProject && item.currentProject == 1) {
            return item.currentProject == 1
          }
        })
        this.form.decisionBasisPersion = selectedProject.projectManager
        this.form.projectInfo.projectName = selectedProject.projectName
        this.form.projectInfo.projectCode = selectedProject.projectCode
        this.form.projectId = selectedProject.id
      } else {
        //根据项目id查询
        this.form.decisionBasisPersion = this.projectObj[0].projectManager
        this.form.projectInfo.projectName = this.projectObj[0].projectName
        this.form.projectInfo.projectCode = this.projectObj[0].projectCode
        this.form.projectId = this.projectObj[0].id
      }
    },
    handleRowDBClick(data) {
      this.dialogTitle = '修改'
      this.$http
        .post('${cqxy}/biz/projectApproval/decisionBasis/v1/detail/' + data.id)
        .then(res => {
          this.dialogVisible = true
          let response = res.data.value
          this.form = response
          this.form.decisionAnnualPlanName = ''
          this.form = {...this.form}
          this.form.decisionAnnualPlanId &&
            this.getByIdAnnualPlan(this.form.decisionAnnualPlanId)
        })
    },
    getByIdAnnualPlan(id) {
      this.$http
        .post(
          '${cqxy}/biz/projectApproval/decisionBasis/decisionAnnualPlan/v1/detail/' +
            id
        )
        .then(res => {
          this.form.decisionAnnualPlanName = res.data.value.projectName
          this.form = {...this.form}
        })
    },
    handleSelect(selection) {},
    //取消
    handleDialogCancel() {
      this.dialogVisible = false
      this.form = {
        decisionBasisPersion: '',
        projectId: '',
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: []
      }
    },
    //关闭窗口
    handleDialogClose(val) {
      this.dialogVisible = false
      this.form = {
        decisionBasisPersion: '',
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: []
      }
    },
    //提交保存
    handleDialogSubmit(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.loading = true
          this.form.decisionBasisType = this.form.decisionBasisType + ''
          if (this.form.accessoryInfo && this.form.accessoryInfo.length > 0) {
            this.form.accessoryInfo.forEach(item => {
              if (item.id) {
                delete item.id
              }
            })
          }
          this.$http
            .post(
              '${cqxy}/biz/projectApproval/decisionBasis/v1/save',
              this.form
            )
            .then(res => {
              if (res.status == 200) {
                setTimeout(() => {
                  this.$message.success(res.data.message)
                  this.afterSaveData()
                }, 500)
              } else {
                this.$message.error(res.data.message)
              }
              this.loading = false
            })
        }
        //  else if (this.form.accessoryInfo.length === 0) {
        //   this.$message.error('至少上传一个附件')
        // }
        else {
          this.$message({
            message: '项目名称不能为空!',
            type: 'warning'
          })
          return false
        }
      })
    },
    loadData(param, cb) {
      let query = []
      let search = {
        'pm.ID_': this.searchForm.projectId,
        decision_asis_persion_: this.searchForm.decisionBasisPersion,
        decision_basis_time_: this.searchForm.decisionBasisTime,
        decision_basis_type_: this.searchForm.decisionBasisType
      }
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
        this.importData.projectId = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      if (param.querys && param.querys.length) {
        param.querys.push(...query)
      } else {
        param.querys = query
      }

      this.$http
        .post('${cqxy}/biz/projectApproval/decisionBasis/v1/page', param)
        .then(
          resp => {
            let response = resp.data.value
            this.data = response.rows
            this.pageResult = {
              page: response.page,
              pageSize: response.pageSize,
              total: response.total
            }
          },
          error => {
            reject(error)
          }
        )
        .finally(() => {
          if (cb) {
            cb()
          }
        })
    }
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/common.scss';

/deep/ .el-input__suffix > .el-input__icon {
  display: none;
}
</style>
